<template>
  <div>
    <p v-if="error">Error: {{ error }}</p>
    <canvas v-else id="qrcode-canvas"></canvas>
  </div>
</template>

<script>
module.exports = {
  name: "qrcode",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    sourcesConfigured: {
      type: Boolean,
      required: false
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  data: function() {
    return {
      canvas: null,
      error: ""
    };
  },
  computed: {
    backendAddress: function() {
      return this.$store.getters.primaryConnectionIP;
    },
    content: function() {
      // Check for `content` key to avoid issues with incomplete conf-builder from previous versions.
      // FIXME: Remove conditional once a) templates are compiled – then use optional chaining or b) defaults are completely initialized in the backend.
      return this.currentSettings.content &&
        this.currentSettings.content.length > 0
        ? this.prefix(this.currentSettings.content)
        : `http://${this.backendAddress}/settings/`;
    }
  },
  watch: {
    currentSettings: function(newVal, oldVal) {
      if (newVal.content !== oldVal.content) {
        this.regenerateQRCode();
      }
    },
    backendAddress: function(newVal, oldVal) {
      if (newVal === undefined) {
        this.error = "No valid backend IP";
        return;
      }
      if (newVal !== oldVal) {
        this.regenerateQRCode();
      }
    }
  },
  mounted: function() {
    let s = document.createElement("script");
    s.async = true;
    s.src = `${this.backendUrl}assets/widgets/qrcode/scripts/qrcode.min.js`;
    document.body.appendChild(s);

    window.setTimeout(() => {
      this.canvas = document.getElementById("qrcode-canvas");
      this.generateQRCode();
    }, 1000);
  },
  methods: {
    prefix: function(content) {
      if (["geo", "tel"].includes(this.currentSettings.inputType)) {
        return `${this.currentSettings.inputType}${content}`;
      } else {
        return content;
      }
    },
    clearCanvas: function() {
      this.canvas
        .getContext("2d")
        .clearRect(0, 0, this.canvas.width, this.canvas.height);
    },
    generateQRCode: function() {
      QRCode.toDataURL(
        this.canvas,
        this.content,
        { margin: 2, width: this.canvas.clientWidth },
        function(error) {
          if (error) this.error = error;
        }
      );
    },
    regenerateQRCode: function() {
      this.clearCanvas();
      this.generateQRCode();
    }
  }
};
</script>
<style scoped>
#qrcode-canvas {
  max-width: 100%;
}
</style>
